<template>
  <div class="table-display-panel query-display-panel d-flex flex-grow-1 flex-column">
    <!-- loading spinner -->
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-auto">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
          </span>
        </div>
      </div>
    </template>

    <!-- error on download -->
    <template v-else-if="error">
      <div class="d-flex flex-grow-1">
        <div class="text-center mx-auto my-auto">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error }}</div>
        </div>
      </div>
    </template>

    <template v-else>
      <!-- main table container -->
      <div class="table-data-container d-flex flex-grow-0 flex-row py-4">

        <!-- table header -->
        <div class="table-header d-flex flex-column flex-grow-0 bg-light">
          <span class="px-2 py-2">Dia</span>
          <span class="px-2 py-1">Hora</span>
          <span class="px-2 py-1">Temperatura</span>
          <span class="px-2 py-1">Humidade</span>
          <span class="px-2 py-1">Pressão</span>
          <span class="px-2 py-1">Precipitação</span>
          <span class="px-2 py-1">Dir. Vento</span>
          <span class="px-2 py-1">Int. Vento</span>
        </div>
        <div class="table-header d-flex flex-column flex-grow-0 bg-light pr-2">
          <span class="text-right py-2"><br></span>
          <span class="text-right py-1"><br></span>
          <span class="text-right py-1"><small>ºC</small></span>
          <span class="text-right py-1"><small>%</small></span>
          <span class="text-right py-1"><small>hPa</small></span>
          <span class="text-right py-1"><small>mm</small></span>
          <span class="text-right py-1"><br></span>
          <span class="text-right py-1"><small>km/h</small></span>
        </div>

        <!-- table data -->
        <div class="table-data d-flex flex-row flex-grow-1 position-relative" style="overflow-x: scroll">
          <div class="d-flex flex-grow-1" style="max-width: 0px">
            <div class="d-flex flex-grow-0 flex-row">
              <table-day-column :latitude="latitude" :longitude="longitude" :day="0" :skipzero="true"/>
              <table-day-column :latitude="latitude" :longitude="longitude" :day="1"/>
            </div>
          </div>
        </div>
    
      </div>
    </template>

  </div>
</template>

<script>
import moment from 'moment'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import { buildQueryUrl, getFeatureInfo } from '@/query/retrieve'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import TableDayColumn from '@/workspace/components/query/TableDayColumn'

export default {
  name: 'tabledisplaypanel',

  mixins: [
    WorkspaceGetter,
  ],

  props: {
    latitude: {
      type: Number,
      required: true
    },

    longitude: {
      type: Number,
      required: true
    }
  },

  data() {
    return {
      loading: true,
      error: null,
    }
  },

  computed: {
    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      },
    },

    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    queryRequestCache: {
      get() {
        return this.$store.getters.workspaceQueryRequestCache(this.workspaceId)
      }
    },
  },

  methods: {
    tableDataSources() {
      return [
        'ecmwf.temperature.atlantic',
        'ecmwf.relative_humidity.atlantic',
        'ecmwf.pressure.atlantic',
        'ecmwf.wind_direction.atlantic',
        'ecmwf.wind_intensity.atlantic',
      ]
    },

    generateTimeList() {
      return [...Array(48).keys()].map((i) => {
        return moment.unix(this.referenceTime).add(i, 'hours').format('YYYY-MM-DDTHH:00:00')
      })
    },

    parseFeatureInfoResponse(response) {
      this.$store.dispatch('setWorkspaceQueryRequestCache', {
        workspaceId: this.workspaceId,
        requestHash: response.config.url,
        response: response
      })
    },
  },

  mounted() {
    let requests = this.tableDataSources().map((source) => {
      return buildQueryUrl({
        latitude: this.latitude,
        longitude: this.longitude,
        layer: source,
        reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
        time: this.generateTimeList(),
      })
    }).filter((url) => {
      return !(url in this.queryRequestCache)
    }).map((url) => {
      return getFeatureInfo(url)
    })

    Promise.all(requests).then((responses) => {
      responses.forEach((response) => {
        this.parseFeatureInfoResponse(response)
      })
      this.loading = false
    }).catch(() => {
      this.error = 'Ocorreu um erro ao descarregar os dados. Por favor tente mais tarde.'
      this.loading = false
    })
  },

  components: {
    ClipLoader,
    TableDayColumn,
  },
}
</script>

<style>
.table-data-container {
  font-size: 0.8rem;
}
</style>
